searchNodes=[{"type":"module","title":"Iconify","doc":"Phoenix helpers for using 100,000+ SVG icons from 100+ icon sets compiled by Iconify (visit that site to browse the sets available and preview the icons) It copies only the icons you use from the iconify library into your project, preparing them on-the-fly when you first use an icon in a view or component (either at compile time if using the Surface component, or on the first run during development). It can be configured to embed the icons one of three ways: css (default): generate a single CSS file containing SVGs of all the icons used img (default for emojis): to create SVG files in your static assets, used to be included with img tags and loaded over HTTP (you may want to include svg-inject on your site to enable styling of the SVGs, e.g. to change their colour) inline : to generate a Phoenix Component for each icon used, used to embed the icons as svg tags inline in the HTML of your views (meaning the SVG will be included in LiveView diffs) set : to generate an SVG sprite set for each family, and reference icons with a use tag inside of inline SVGs. There is also an optional integration of phoenix_live_favicon so you can set an icon (or emoji) as favicon on a page with Iconify.maybe_set_favicon(socket, icon_name_or_emoji) . Installation def deps do [ { :iconify_ex , &quot;~&gt; 0.1.0&quot; } ] end After running mix deps.get you need to fetch the latest iconify icon sets by running something like: cd deps/iconify_ex/assets &amp;&amp; yarn &amp;&amp; cd ../../.. Usage Add import Iconify in your Phoenix or LiveView module where you want to use it (or just once in the macros in your Web module). Set one of these options in config to choose which approach you want to use (see above for explanations): config :iconify_ex, :mode, :css config :iconify_ex, :mode, :img config :iconify_ex, :mode, :inline config :iconify_ex, :mode, :set If using CSS mode, you'll need to include the CSS file in your layout (e.g. &lt;link phx-track-static rel=&quot;stylesheet&quot; href={~p&quot;/images/icons/icons.css&quot;} /&gt; in your app's equivalent of lib/my_app_web/components/layouts/root.html.heex ) and set some default styles that will be applied to all icons, by adding something like this to your app's main CSS (e.g. assets/css/app.css ): [iconify] { background-color: currentColor; -webkit-mask-size: cover; mask-size: cover; min-width: 0.5rem; min-height: 0.5rem; } Other configurations include: config :iconify_ex , :fallback_icon , &quot;heroicons-solid:question-mark-circle&quot; # when an icon is not found config :iconify_ex , :generated_icon_modules_path , &quot;./lib/web/icons&quot; # for :inline mode config :iconify_ex , :generated_icon_static_path , &quot;./priv/static/images/icons&quot; # where CSS and images are stored config :iconify_ex , :generated_icon_static_url , &quot;/images/icons/&quot; # where CSS and images are served from In all three cases, usage is the same (meaning you can easily switch between modes at any time) by including a component: Embed an icon using default classes (copy the icon name from the iconify website ): &lt;.iconify icon=&quot;heroicons-solid:collection&quot; /&gt; Specify custom classes: &lt;.iconify icon=&quot;heroicons-solid:collection&quot; class=&quot;w-8 h-8 text-base-content&quot; /&gt; Or if you use Surface , it is highly recommended to use the macro component which means icons will be prepared at compile time rather than runtime: Add alias Iconify.Icon to your Web module, and then: &lt;#Icon iconify=&quot;heroicons-solid:collection&quot; /&gt; If your icon is dynamic, you'll still want to use the first form: &lt;.iconify icon={@my_icon} /&gt; Note: when using the CSS mode, there's sometimes a race condition that adds an icon several times. Until a fix is found you can run something like sort -u -o icons_dir/icons.css icons_dir/icons.css to clean up the CSS file.","ref":"Iconify.html"},{"type":"function","title":"Iconify.add_icon_to_css/2","doc":"","ref":"Iconify.html#add_icon_to_css/2"},{"type":"function","title":"Iconify.dev_env?/0","doc":"","ref":"Iconify.html#dev_env?/0"},{"type":"function","title":"Iconify.emoji?/1","doc":"Checks if the icon is part of a known emoji set or any set that doesn't support CSS mode. Examples iex&gt; Iconify . emoji? ( &quot;twemoji:smile&quot; ) true iex&gt; Iconify . emoji? ( &quot;heroicons-solid:user&quot; ) false","ref":"Iconify.html#emoji?/1"},{"type":"function","title":"Iconify.fallback_icon/0","doc":"Returns the fallback icon name. Examples iex&gt; Iconify . fallback_icon ( ) &quot;heroicons-solid:question-mark-circle&quot;","ref":"Iconify.html#fallback_icon/0"},{"type":"function","title":"Iconify.generate_css_from_components/0","doc":"Generates CSS icons from existing components. Examples iex&gt; Iconify . generate_css_from_components ( ) :ok","ref":"Iconify.html#generate_css_from_components/0"},{"type":"function","title":"Iconify.generate_css_from_static_files/0","doc":"Generates CSS icons from existing static files. Examples iex&gt; Iconify . generate_css_from_static_files ( ) :ok","ref":"Iconify.html#generate_css_from_static_files/0"},{"type":"function","title":"Iconify.generate_sets_from_components/0","doc":"Generates icon sets from existing components. Examples iex&gt; Iconify . generate_sets_from_components ( ) [ :ok , :ok , ... ]","ref":"Iconify.html#generate_sets_from_components/0"},{"type":"function","title":"Iconify.iconify/1","doc":"Renders an icon as a Phoenix.Component based on the given assigns. Examples iex&gt; assigns = %{ icon : &quot;heroicons-solid:user&quot; , class : &quot;w-6 h-6&quot; } iex&gt; Iconify . iconify ( assigns ) # Returns rendered icon HTML","ref":"Iconify.html#iconify/1"},{"type":"function","title":"Iconify.list_all_existing/0","doc":"Lists all existing icons (components and CSS). Examples iex&gt; Iconify . list_all_existing ( ) %{ &quot;HeroiconsSolid&quot; =&gt; [ Iconify.HeroiconsSolid.User , &quot;user&quot; , ... ] , &quot;HeroiconsOutline&quot; =&gt; [ Iconify.HeroiconsOutline.User , &quot;user&quot; , ... ] }","ref":"Iconify.html#list_all_existing/0"},{"type":"function","title":"Iconify.list_components/0","doc":"Lists all available icon components. Examples iex&gt; Iconify . list_components ( ) %{ &quot;HeroiconsSolid&quot; =&gt; [ Iconify.HeroiconsSolid.User , Iconify.HeroiconsSolid.Star , ... ] , &quot;HeroiconsOutline&quot; =&gt; [ Iconify.HeroiconsOutline.User , Iconify.HeroiconsOutline.Star , ... ] }","ref":"Iconify.html#list_components/0"},{"type":"function","title":"Iconify.list_icons_in_css/0","doc":"Lists all icons defined in the CSS file. Examples iex&gt; Iconify . list_icons_in_css ( ) %{ &quot;HeroiconsSolid&quot; =&gt; [ &quot;user&quot; , &quot;star&quot; , ... ] , &quot;HeroiconsOutline&quot; =&gt; [ &quot;user&quot; , &quot;star&quot; , ... ] }","ref":"Iconify.html#list_icons_in_css/0"},{"type":"function","title":"Iconify.manual/2","doc":"Prepares and renders an icon. Examples iex&gt; Iconify . manual ( &quot;heroicons-solid:user&quot; , mode : :css ) # Returns rendered icon HTML or data","ref":"Iconify.html#manual/2"},{"type":"function","title":"Iconify.maybe_set_favicon/2","doc":"Sets the favicon for a Phoenix LiveView socket. Examples iex&gt; socket = % Phoenix.LiveView.Socket { } iex&gt; Iconify . maybe_set_favicon ( socket , &quot;heroicons-solid:star&quot; ) % Phoenix.LiveView.Socket { }","ref":"Iconify.html#maybe_set_favicon/2"},{"type":"function","title":"Iconify.path/0","doc":"Returns the configured path for generated icon modules. Examples iex&gt; Iconify . path ( ) &quot;./lib/web/icons&quot;","ref":"Iconify.html#path/0"},{"type":"function","title":"Iconify.prepare/2","doc":"Prepares an icon based on the given assigns and mode (such as CSS, inline SVG, or image URL). Examples iex&gt; { :css , _function , %{ icon : &quot;heroicons-solid:user&quot; , class : &quot;w-4 h-4&quot; , icon_name : &quot;heroicons-solid:user&quot; } } = Iconify . prepare ( %{ icon : &quot;heroicons-solid:user&quot; } , :css ) iex&gt; Iconify . prepare ( %{ icon : &quot;heroicons-solid:user&quot; } , :inline ) { :inline , _fun , %{ icon : &quot;heroicons-solid:user&quot; } } iex&gt; Iconify . prepare ( %{ icon : &quot;heroicons-solid:user&quot; } , :img ) { :img , _fun , %{ src : &quot;/images/icons/heroicons-solid/user.svg&quot; } } iex&gt; Iconify . prepare ( %{ icon : &quot;heroicons-solid:user&quot; } , :set ) { :set , _fun , %{ href : &quot;/images/icons/heroicons-solid.svg#user&quot; } } iex&gt; Iconify . prepare ( %{ icon : &quot;twemoji:rabbit&quot; } ) { :img , _fun , %{ src : &quot;/images/icons/twemoji/rabbit.svg&quot; } } iex&gt; Iconify . prepare ( %{ icon : &quot;non-existent-icon&quot; } ) { :css , _fun , %{ icon_name : &quot;heroicons-solid:question-mark-circle&quot; } } &gt; Iconify . prepare ( %{ icon : &quot;&lt;svg&gt;...&lt;/svg&gt;&quot; } ) { :inline , _fun , %{ icon : &quot;&lt;svg&gt;...&lt;/svg&gt;&quot; } }","ref":"Iconify.html#prepare/2"},{"type":"function","title":"Iconify.prepare_entire_icon_family/2","doc":"Prepares an entire icon family for a particular mode. Examples iex&gt; Iconify . prepare_entire_icon_family ( &quot;heroicons-solid&quot; , :inline ) # creates a Phoenix.Component module file for each icon in the set","ref":"Iconify.html#prepare_entire_icon_family/2"},{"type":"function","title":"Iconify.static_path/0","doc":"Returns the configured path for generated static icon assets. Examples iex&gt; Iconify . static_path ( ) &quot;./assets/static/images/icons&quot;","ref":"Iconify.html#static_path/0"},{"type":"function","title":"Iconify.static_url/0","doc":"Returns the configured URL for generated static icon assets. Examples iex&gt; Iconify . static_url ( ) &quot;/images/icons&quot;","ref":"Iconify.html#static_url/0"},{"type":"function","title":"Iconify.using_svg_inject?/0","doc":"Checks if SVG injection is enabled in config. Examples iex&gt; Iconify . using_svg_inject? ( ) false","ref":"Iconify.html#using_svg_inject?/0"},{"type":"module","title":"Iconify.Icon","doc":"A Surface component for rendering icons using various methods. Specifying what icon to use iconify or icon : Any icon from Iconify ( https://icones.js.org ) solid : Shorthand for Heroicons solid icons outline : Shorthand for Heroicons outline icons Extra Properties svg : Optionally pass SVG markup directly mode : Sets what rendering mode to use (see Iconify docs) class : Any CSS classes to apply to the icon Examples iex&gt; alias Iconify.Icon iex&gt; ~F&quot;&lt;#Icon iconify=&quot;heroicons - solid :user &quot; class=&quot; w - 6 h - 6 &quot; /&gt;&quot; # Returns rendered icon HTML iex&gt; ~F&quot;&lt;#Icon solid=&quot;user &quot; class=&quot; w - 6 h - 6 &quot; /&gt;&quot; iex&gt; ~F&quot;&lt;#Icon svg=&quot; &lt; svg &gt; ... &lt; / svg &gt; &quot; class=&quot; w - 6 h - 6 &quot; /&gt;&quot; Properties iconify :string, required: false, static: true icon :string, required: false, static: true solid :string, required: false, static: true outline :string, required: false, static: true svg :string, default: nil, required: false, static: true mode :atom, required: false, static: true class :css_class, default: nil","ref":"Iconify.Icon.html"},{"type":"function","title":"Iconify.Icon.class_to_string/1","doc":"","ref":"Iconify.Icon.html#class_to_string/1"},{"type":"function","title":"Iconify.Icon.expand/3","doc":"","ref":"Iconify.Icon.html#expand/3"},{"type":"macro","title":"Iconify.Icon.icon_name/1","doc":"","ref":"Iconify.Icon.html#icon_name/1"},{"type":"extras","title":"Iconify for Phoenix","doc":"Phoenix helpers for using 100,000+ SVG icons from 100+ icon sets compiled by Iconify (visit that site to browse the sets available and preview the icons) It copies only the icons you use from the iconify library into your project, preparing them on-the-fly when you first use an icon in a view or component (either at compile time if using the Surface component, or on the first run during development). It can be configured to embed the icons one of three ways: css (default): generate a single CSS file containing SVGs of all the icons used img (default for emojis): to create SVG files in your static assets, used to be included with img tags and loaded over HTTP (you may want to include svg-inject on your site to enable styling of the SVGs, e.g. to change their colour) inline : to generate a Phoenix Component for each icon used, used to embed the icons as svg tags inline in the HTML of your views (meaning the SVG will be included in LiveView diffs) set : to generate an SVG sprite set for each family, and reference icons with a use tag inside of inline SVGs. There is also an optional integration of phoenix_live_favicon so you can set an icon (or emoji) as favicon on a page with Iconify.maybe_set_favicon(socket, icon_name_or_emoji) .","ref":"readme.html"},{"type":"extras","title":"Iconify for Phoenix - Installation","doc":"def deps do [ { :iconify_ex , &quot;~&gt; 0.1.0&quot; } ] end After running mix deps.get you need to fetch the latest iconify icon sets by running something like: cd deps/iconify_ex/assets &amp;&amp; yarn &amp;&amp; cd ../../..","ref":"readme.html#installation"},{"type":"extras","title":"Iconify for Phoenix - Usage","doc":"Add import Iconify in your Phoenix or LiveView module where you want to use it (or just once in the macros in your Web module). Set one of these options in config to choose which approach you want to use (see above for explanations): config :iconify_ex, :mode, :css config :iconify_ex, :mode, :img config :iconify_ex, :mode, :inline config :iconify_ex, :mode, :set If using CSS mode, you'll need to include the CSS file in your layout (e.g. &lt;link phx-track-static rel=&quot;stylesheet&quot; href={~p&quot;/images/icons/icons.css&quot;} /&gt; in your app's equivalent of lib/my_app_web/components/layouts/root.html.heex ) and set some default styles that will be applied to all icons, by adding something like this to your app's main CSS (e.g. assets/css/app.css ): [iconify] { background-color: currentColor; -webkit-mask-size: cover; mask-size: cover; min-width: 0.5rem; min-height: 0.5rem; } Other configurations include: config :iconify_ex , :fallback_icon , &quot;heroicons-solid:question-mark-circle&quot; # when an icon is not found config :iconify_ex , :generated_icon_modules_path , &quot;./lib/web/icons&quot; # for :inline mode config :iconify_ex , :generated_icon_static_path , &quot;./priv/static/images/icons&quot; # where CSS and images are stored config :iconify_ex , :generated_icon_static_url , &quot;/images/icons/&quot; # where CSS and images are served from In all three cases, usage is the same (meaning you can easily switch between modes at any time) by including a component: Embed an icon using default classes (copy the icon name from the iconify website ): &lt;.iconify icon=&quot;heroicons-solid:collection&quot; /&gt; Specify custom classes: &lt;.iconify icon=&quot;heroicons-solid:collection&quot; class=&quot;w-8 h-8 text-base-content&quot; /&gt; Or if you use Surface , it is highly recommended to use the macro component which means icons will be prepared at compile time rather than runtime: Add alias Iconify.Icon to your Web module, and then: &lt;#Icon iconify=&quot;heroicons-solid:collection&quot; /&gt; If your icon is dynamic, you'll still want to use the first form: &lt;.iconify icon={@my_icon} /&gt; Note: when using the CSS mode, there's sometimes a race condition that adds an icon several times. Until a fix is found you can run something like sort -u -o icons_dir/icons.css icons_dir/icons.css to clean up the CSS file.","ref":"readme.html#usage"}]